<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseExtendedRelPax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseExtendedRelPax extends AbstractStructArrayBase
{
    /**
     * The RelPax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseExtendedRelPax[]
     */
    public $RelPax;
    /**
     * Constructor method for ArrayOfJP_CruiseExtendedRelPax
     * @uses ArrayOfJP_CruiseExtendedRelPax::setRelPax()
     * @param \StructType\JP_CruiseExtendedRelPax[] $relPax
     */
    public function __construct(array $relPax = array())
    {
        $this
            ->setRelPax($relPax);
    }
    /**
     * Get RelPax value
     * @return \StructType\JP_CruiseExtendedRelPax[]|null
     */
    public function getRelPax()
    {
        return $this->RelPax;
    }
    /**
     * This method is responsible for validating the values passed to the setRelPax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelPax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelPaxForArrayConstraintsFromSetRelPax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseExtendedRelPaxRelPaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseExtendedRelPaxRelPaxItem instanceof \StructType\JP_CruiseExtendedRelPax) {
                $invalidValues[] = is_object($arrayOfJP_CruiseExtendedRelPaxRelPaxItem) ? get_class($arrayOfJP_CruiseExtendedRelPaxRelPaxItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseExtendedRelPaxRelPaxItem), var_export($arrayOfJP_CruiseExtendedRelPaxRelPaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelPax property can only contain items of type \StructType\JP_CruiseExtendedRelPax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseExtendedRelPax[] $relPax
     * @return \ArrayType\ArrayOfJP_CruiseExtendedRelPax
     */
    public function setRelPax(array $relPax = array())
    {
        // validation for constraint: array
        if ('' !== ($relPaxArrayErrorMessage = self::validateRelPaxForArrayConstraintsFromSetRelPax($relPax))) {
            throw new \InvalidArgumentException($relPaxArrayErrorMessage, __LINE__);
        }
        $this->RelPax = $relPax;
        return $this;
    }
    /**
     * Add item to RelPax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseExtendedRelPax $item
     * @return \ArrayType\ArrayOfJP_CruiseExtendedRelPax
     */
    public function addToRelPax(\StructType\JP_CruiseExtendedRelPax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseExtendedRelPax) {
            throw new \InvalidArgumentException(sprintf('The RelPax property can only contain items of type \StructType\JP_CruiseExtendedRelPax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelPax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseExtendedRelPax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseExtendedRelPax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseExtendedRelPax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseExtendedRelPax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseExtendedRelPax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelPax
     */
    public function getAttributeName()
    {
        return 'RelPax';
    }
}
